Subject: RE: [External] : Re: bug#71801: emacs 29.4 windows binaries

From: Drew Adams <[email-masked]>
Date: Fri, 5 Jul 2024 19:33:21 +0000

> > It seems to start OK but I get this warning repeated
> > periodically (forever) in buffer *Warnings*:
> >
> >  ■  Warning (comp): x86_64-w64-mingw32-gcc-11.3.0: fatal error: cannot
> execute 'as': CreateProcess: No such file or directory
> 
> You need to install GNU Binutils, which is where as.exe, the GNU
> assembler, comes from.

Why?  What is it, where to get it, and how to
install it?

And there's nothing in that warning tells you
anything about having to "install GNU Binutils".

We've never had to install any additional
executables for Emacs on Windows before now.

If you want image support or grep support etc.,
then yes, you've needed to download other stuff,
but never just to run Emacs - the Emacs binary
suffices.  And you saw no warnings if you didn't
download that other stuff.

> (If GCC that emits the above error message is
> part of the Emacs installation, then Corwin should make sure Binutils
> are part of the installation as well.)

Corwin: Please do whatever is appropriate/needed.
Thank you.

> > I haven't noticed other problems yet (with -Q), but
> > is the continual emission of that warning expected?
> 
> Yes.

Why is that a good thing to do?  This is like a
fire alarm that keeps blasting till someone turns
it off.  Is that really appropriate here?

> > Clicking that black, square icon pops up this
> > question as a menu:
> >
> >   Suppress `comp' warnings?
> >   _________________________
> >
> >   Yes, Ignore `Comp' Warnings Completely
> >   No, Just Disable Showing Them
> >   Quit And Do Nothing
> >
> > I have no idea what any of that means.
> 
> It allows you to disable these warnings, so that they don't annoy you.

Sure.  But _what are_ `Comp' warnings?  How is
someone to know whether they might want to (or
need to) ignore, disable, or do nothing?

Expecting someone to decide which to do makes
no sense if they have no idea what the meaning
or consequences are (beyond not seeing msgs).

Warnings should be for things that you need to
be WARNed about.  If this is one such thing,
then we should tell users what the "this" is.

 *****
 WARNING - there's a FOOBAR in the vicinity!
 Quick!  What do you want to do about it?
 *****

> > It doesn't seem very helpful - no link to any other info etc.
> 
> I'm not sure I understand what other info is needed.  The warning says
> 
>   Warning (comp): SOMETHING
> 
> and the prompt asks about suppressing "comp" warnings, which fits the
> warning ID.  You are showed 3 possible answers with the meaning of
> each one of them.  What is not clear here?

Nothing is clear.  I'm a user.  I didn't build
Emacs.  I see this:

 x86_64-w64-mingw32-gcc-11.3.0: fatal error: cannot
 execute 'as': CreateProcess: No such file or directory

Is that a problem?  I'm warned about it, so I
guess maybe it is.  Is it a problem that I'm
expected, and that I can, do something about?
If so, what needs to be done?

> > I also notice that if I put point on that icon and
> > hit RET I get the question in the minibuffer, but
> > with the additional key `?' highlighted (no such
> > option in the menu version).
> >
> > I hit `?' and this is shown in buffer *Multiple
> > Choice Help*:
> >
> > Suppress `comp' warnings?
> >
> > y: yes, ignore `comp'    n: no, just disable      q: quit and do
> > warnings completely      showing them             nothing
> >
> > That "help" text seems worse than useless.
> 
> It just repeats what was in the menu.

And you're just repeating what I reported.
Why have the `?' and `RET' binding, which
just repeats the text you're clicking `?'
for help about?

`?', like an `i' Information icon, should
tell you something different, or something
more, than the text you're already looking at.

> > I guess this "help" is new UI intended to somehow
> > help users.  To me it seems only to confuse and
> > obfuscate, and in a fairly heavy-handed way.
> 
> If you think about it for a few moments, I'm sure you will see the
> light.  It's really very simple.

If you think about it for a few moments, I
hope you'll see it's either misguided or
it's missing something.

We get a "security fix" point release, and
the first thing seen is an indecipherable,
continually popped-up scary WARNING.  No
help from Emacs to understand what's involved -
what the danger/problem is, or what to do
about it.

And your response is that this is all OK
and expected?